#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <stdint.h>

#include <linux/kernel.h>
#include <stdio.h>
#include <sys/sysinfo.h>



#include <curl/curl.h>

//#include "utils.h"
#include "pear_log.h"
#include "pear_utils.h"
#include "pear_json.h"
#include "pear_manager.h"
#include "pear_curl.h"



/*
    char *path =getenv ("PATH"); 
    if (path !=NULL) 
    {
        LOGI("[pear] path  is   %s " , path);
    }
    setenv("SHADOWFOG_PASSWD","Aa123456",1);
*/

//  http://stackoverflow.com/questions/22181969/changing-password-using-popen-in-c-code


char * passwdfile="/etc/shadowfog/passwd.json";
char * passwdfileresult="/etc/shadowfog/passwd.result";
extern char pear_lower_case []; 
extern char pear_upper_case []; 
extern char pear_special []; 
void  shadow_gen_passwd (char *  password , int type)
{
   int r = 0;
 
   int index=0;
   char lower_ch , upper_ch , special_ch;
   
    srand(mbedtls_timing_hardclock());
    r=rand();
    index=r%10;
    lower_ch = pear_lower_case[index];
	
    if(type==0)
    {
        
        sprintf(password,"%d",r%100000000);
	 //sprintf(password,"%06d",r);
	 return;
    }

    srand(mbedtls_timing_hardclock());
    r=rand();
    index=r%10;
    special_ch = pear_special[index];

    srand(mbedtls_timing_hardclock());
    r=rand();
    index=r%10;
    upper_ch = pear_upper_case[index];
    sprintf(password,"%d%c%c%c",r,lower_ch , upper_ch , special_ch);
}


#if PEAR_ENABLE_CHANGE_PASSWD
int  shadow_passwd_post (char * host)
{
    int s = 0;
    int path_size = 256;

    char msg[32]    = {0x00};
    char cmd[512]   = {0x00};
    char post[512]  = {0x00};
    char temp[4096] = {0x00};

    FILE * pipe_reader = NULL;

    sprintf(post, "{"
                  "\"auth\":\"%s\","
                  "\"mac\":\"%s\","
                  "\"passwd\":\"%s\","
                  "\"ip\":\"%s\""
                  "}",
                  shadowfog,
                  pear_fog_info.mac,
                  pear_fog_info.passwd,
                  pear_fog_info.extern_ip);

    sprintf(cmd ,"%s/fogs/passwd", host);
    LOGI("[pear] cmd: %s", cmd);

    s = pear_curl_cmd("POST", cmd, NULL, pear_curl_header, post, strlen(post), temp);

    LOGI("read feedback bytes %d , and content : %s", s, temp);

    pear_json_get_string(temp, "msg", msg);
    if (!strcmp(msg,"ok"))
    { 
        LOGI("[pear] post passwd ok");
        return 0;
    }
    else
    { 
        LOGI("[pear] post passwd fail");
        return 1;
    }
   //{"code":"0","msg":"ok","net_type":""}
   //{"code":"2","msg":"fail","net_type":""}
    return 0;
   
	
}

#include <dpopen.h>
// https://www.ibm.com/developerworks/cn/linux/l-pipebid/
int shadow_change_password()
{
    char temp[256]={0x00};
    char newpasswd[64]={0x00};
    char oldpasswd[64]={0x00};
	
    int ret=0;
     //  get old passwd
     FILE *f = fopen(passwdfile, "r");
     if (f == NULL) {
            LOGI("unable to open password  file : %s ",passwdfile);
        return -1;
    }
     fread(temp, 1, 256, f);
    pear_json_get_string(temp, "passwd", oldpasswd);
     LOGE("[pear] oldpasswd is  %s ",oldpasswd);
     pclose(f);
     memset(temp,0x00,256);
     if(strlen(oldpasswd)==0)
     {
         return -1;
     }
     //shadow_gen_passwd(newpasswd,1);
     strcpy(newpasswd,"Bb123456");
     //strcpy(newpasswd,"Aa123456");
     
    /////////////////////////////////////////////////////////////
    // notify server 
    memcpy(pear_fog_info.passwd,oldpasswd,strlen(oldpasswd));
    ret= shadow_passwd_post(shadowfog_real_host_address);
    if(ret)
    {
       return -1;
    }
    ///////////////////////////////////////////////////////////////
    //  change passwd do
    #if 0
    char cmd[32];
    sprintf(cmd, "passwd  %s ");
    f= popen(cmd, "w");
    fprintf(f, "%s\n", oldpasswd);
    fprintf(f, "%s\n", newpasswd);
    fprintf(f, "%s\n", newpasswd);
    fread(temp, 1, 256, f);
    fclose(f);
    LOGI("[pear] passwd return is %s",temp);
    #endif 

    char    line[1024];
    FILE    *fp;
    fp = dpopen("passwd");
    if (fp == NULL) {
        perror("dpopen error");
        exit(1);
    }
    fprintf(fp, "%s\n", oldpasswd);
    fprintf(fp, "%s\n", newpasswd);
    fprintf(fp, "%s\n", newpasswd);

    if (dphalfclose(fp) < 0) {
        LOGI("[pear]dphalfclose error");
        return -1;
    }
    //for (;;) {
    //    if (fgets(line, 1024, fp) == NULL)
    //        break;
    //    LOGI("[pear] line is %s",line);
    //}

    fread(line, 1, 1024, fp);
    LOGI("[pear] line is %s",line);
	
    dpclose(fp);

    
    if(strstr(temp,"successfully"))
    {
         LOGI("[pear] passwd successfully ");
    }
    else
    {
         LOGI("[pear] passwd failed ");
	   return -1;
    }
    ////////////////////////////////////////
    // store new passwd
    f = fopen(passwdfile, "w+");
    if (f == NULL) {
        LOGI("write passwd to json fail when fopen");
        return -1;
    }
    fprintf(f, "{\n");
    fprintf(f, "\"passwd\":\"%s\"", newpasswd);
    fprintf(f, "\n}");
    fclose(f);

     /////////////////////////////////////////////////////////////
    // notify server 
    memcpy(pear_fog_info.passwd,newpasswd,strlen(newpasswd));
    ret= shadow_passwd_post(shadowfog_real_host_address);
    if(ret)
    {
       return -1;
    }
    return 0;
}

#endif

