#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <stdint.h>

#include "pear_speed.h"
//#include "utils.h"
#include "pear_log.h"
#include "pear_manager.h"
#include "pear_curl.h"

//  http://www.ttlsa.com/linux/use-speedtest-cli-test-internet-speed/
//  git clone https://github.com/sivel/speedtest-cli.git
//  python setup.py install

//  ImportError: No module named 'setuptools'
//

// awk  sed  grep 

// 1.  apt-get install python-pip
// 2.  pip install --upgrade pip
// 3.  pip install  speedtest-cli
// 4.  speedtest-cli  --simple

/*
speedtest-cli --source 5081  --simple
Ping: 17.081 ms
Download: 12.00 Mbit/s
Upload: 1.47 Mbit/s
*/

pear_speed_info_t pear_speed_info;

#if 0
static void
dump(char *tag, char *text, int len)
{
    int i;
    printf("%s: ", tag);
    for (i = 0; i < len; i++)
        printf("0x%02x ", (uint8_t)text[i]);
    printf("\n");
}
#endif

void pear_speed_dump()
{
    LOGI("[pear] speed dump ping %s ",pear_speed_info.ping);
    LOGI("[pear] speed dump download %s ",pear_speed_info.download);
    LOGI("[pear] speed dump upload %s ",pear_speed_info.upload);
    return ;
}
 
void pear_speed_cmp()
{
    if (atoi(pear_speed_info.upload) > atoi(pear_speed_info.upload_max))
    {
        strcpy(pear_speed_info.upload_max, pear_speed_info.upload);
    }

    if (atoi(pear_speed_info.download) > atoi(pear_speed_info.download_max))
    {
        strcpy(pear_speed_info.download_max, pear_speed_info.download);
    }
}

void pear_speed_init()
{
   strcpy(pear_speed_info.ping,"0");
   strcpy(pear_speed_info.upload,"10");
   strcpy(pear_speed_info.download,"10");

   pear_speed_info.speed_update = 0;
   pear_speed_info.speed_enable = 1;
}

int  pear_get_speed()
{
#if 0
    int  ln=0;
    char line[1024];
	
     while( fgets(line,1024,pipe_reader) ) {
       //dump("speed",line,strlen(line));
	ln = strlen(line) - 1;
	if (*line && line[ln] == '\n') 
	    line[ln] = '\0';
	if (*line && line[ln-1] == '\r') 
	    line[ln-1] = '\r';
      //dump("speed",line,strlen(line));
      //LOGI("[pear] %s ",line);
      
	}
#endif

    if(pear_speed_info.speed_enable==0)
    {
       pear_speed_info.speed_update=1;
       LOGI("[pear] not need to speed test");
       return 0;
    }

    pear_speed_info.speed_update=1;
    speedtest_main();
  
    pear_speed_cmp();
    pear_speed_dump();

    return 0;
}


